// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_DDSDCPSINFRASTRUCTUREC_ZFCIP8_H_
#define _TAO_IDL_DDSDCPSINFRASTRUCTUREC_ZFCIP8_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "dds/DCPS/dcps_export.h"
#include "tao/ORB.h"
#include "tao/SystemException.h"
#include "tao/Basic_Types.h"
#include "tao/ORB_Constants.h"
#include "dds/DCPS/ZeroCopyInfoSeq_T.h"
#include "tao/Object.h"
#include "tao/String_Manager_T.h"
#include "tao/Objref_VarOut_T.h"
#include "tao/VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Basic_Argument_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include "tao/UB_String_Arguments.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#include "dds/DdsDcpsCoreC.h"
#include "dds/DdsDcpsConditionSeqC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_Dcps_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace DDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::Long DomainId_t;
  typedef ::CORBA::Long_out DomainId_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::Long ReturnCode_t;
  typedef ::CORBA::Long_out ReturnCode_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long HANDLE_NIL = 0;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long LENGTH_UNLIMITED = -1;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_OK = 0;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_ERROR = 1;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_UNSUPPORTED = 2;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_BAD_PARAMETER = 3;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_PRECONDITION_NOT_MET = 4;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_OUT_OF_RESOURCES = 5;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_NOT_ENABLED = 6;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_IMMUTABLE_POLICY = 7;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_INCONSISTENT_POLICY = 8;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_ALREADY_DELETED = 9;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_TIMEOUT = 10;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_NO_DATA = 11;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RETCODE_ILLEGAL_OPERATION = 12;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong StatusKind;
  typedef ::CORBA::ULong_out StatusKind_out;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong StatusMask;
  typedef ::CORBA::ULong_out StatusMask_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong INCONSISTENT_TOPIC_STATUS = 1U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong OFFERED_DEADLINE_MISSED_STATUS = 2U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong REQUESTED_DEADLINE_MISSED_STATUS = 4U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong OFFERED_INCOMPATIBLE_QOS_STATUS = 32U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong REQUESTED_INCOMPATIBLE_QOS_STATUS = 64U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong SAMPLE_LOST_STATUS = 128U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong SAMPLE_REJECTED_STATUS = 256U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong DATA_ON_READERS_STATUS = 512U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong DATA_AVAILABLE_STATUS = 1024U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong LIVELINESS_LOST_STATUS = 2048U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong LIVELINESS_CHANGED_STATUS = 4096U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong PUBLICATION_MATCHED_STATUS = 8192U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong SUBSCRIPTION_MATCHED_STATUS = 16384U;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct InconsistentTopicStatus;

  typedef
    ::TAO_Fixed_Var_T<
        InconsistentTopicStatus
      >
    InconsistentTopicStatus_var;

  typedef
    InconsistentTopicStatus &
    InconsistentTopicStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export InconsistentTopicStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef InconsistentTopicStatus_var _var_type;
    typedef InconsistentTopicStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SampleLostStatus;

  typedef
    ::TAO_Fixed_Var_T<
        SampleLostStatus
      >
    SampleLostStatus_var;

  typedef
    SampleLostStatus &
    SampleLostStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SampleLostStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SampleLostStatus_var _var_type;
    typedef SampleLostStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum SampleRejectedStatusKind
  {
    NOT_REJECTED,
    REJECTED_BY_INSTANCES_LIMIT,
    REJECTED_BY_SAMPLES_LIMIT,
    REJECTED_BY_SAMPLES_PER_INSTANCE_LIMIT
  };

  typedef SampleRejectedStatusKind &SampleRejectedStatusKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SampleRejectedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        SampleRejectedStatus
      >
    SampleRejectedStatus_var;

  typedef
    SampleRejectedStatus &
    SampleRejectedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SampleRejectedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SampleRejectedStatus_var _var_type;
    typedef SampleRejectedStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    DDS::SampleRejectedStatusKind last_reason;
    DDS::InstanceHandle_t last_instance_handle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct LivelinessLostStatus;

  typedef
    ::TAO_Fixed_Var_T<
        LivelinessLostStatus
      >
    LivelinessLostStatus_var;

  typedef
    LivelinessLostStatus &
    LivelinessLostStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export LivelinessLostStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef LivelinessLostStatus_var _var_type;
    typedef LivelinessLostStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct LivelinessChangedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        LivelinessChangedStatus
      >
    LivelinessChangedStatus_var;

  typedef
    LivelinessChangedStatus &
    LivelinessChangedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export LivelinessChangedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef LivelinessChangedStatus_var _var_type;
    typedef LivelinessChangedStatus_out _out_type;
    
    ::CORBA::Long alive_count;
    ::CORBA::Long not_alive_count;
    ::CORBA::Long alive_count_change;
    ::CORBA::Long not_alive_count_change;
    DDS::InstanceHandle_t last_publication_handle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct OfferedDeadlineMissedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        OfferedDeadlineMissedStatus
      >
    OfferedDeadlineMissedStatus_var;

  typedef
    OfferedDeadlineMissedStatus &
    OfferedDeadlineMissedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export OfferedDeadlineMissedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef OfferedDeadlineMissedStatus_var _var_type;
    typedef OfferedDeadlineMissedStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    DDS::InstanceHandle_t last_instance_handle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct RequestedDeadlineMissedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        RequestedDeadlineMissedStatus
      >
    RequestedDeadlineMissedStatus_var;

  typedef
    RequestedDeadlineMissedStatus &
    RequestedDeadlineMissedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export RequestedDeadlineMissedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef RequestedDeadlineMissedStatus_var _var_type;
    typedef RequestedDeadlineMissedStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    DDS::InstanceHandle_t last_instance_handle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct OfferedIncompatibleQosStatus;

  typedef
    ::TAO_Var_Var_T<
        OfferedIncompatibleQosStatus
      >
    OfferedIncompatibleQosStatus_var;

  typedef
    ::TAO_Out_T<
        OfferedIncompatibleQosStatus
      >
    OfferedIncompatibleQosStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export OfferedIncompatibleQosStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef OfferedIncompatibleQosStatus_var _var_type;
    typedef OfferedIncompatibleQosStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    DDS::QosPolicyId_t last_policy_id;
    DDS::QosPolicyCountSeq policies;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct RequestedIncompatibleQosStatus;

  typedef
    ::TAO_Var_Var_T<
        RequestedIncompatibleQosStatus
      >
    RequestedIncompatibleQosStatus_var;

  typedef
    ::TAO_Out_T<
        RequestedIncompatibleQosStatus
      >
    RequestedIncompatibleQosStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export RequestedIncompatibleQosStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef RequestedIncompatibleQosStatus_var _var_type;
    typedef RequestedIncompatibleQosStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    DDS::QosPolicyId_t last_policy_id;
    DDS::QosPolicyCountSeq policies;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PublicationMatchedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        PublicationMatchedStatus
      >
    PublicationMatchedStatus_var;

  typedef
    PublicationMatchedStatus &
    PublicationMatchedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PublicationMatchedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PublicationMatchedStatus_var _var_type;
    typedef PublicationMatchedStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    ::CORBA::Long current_count;
    ::CORBA::Long current_count_change;
    DDS::InstanceHandle_t last_subscription_handle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SubscriptionMatchedStatus;

  typedef
    ::TAO_Fixed_Var_T<
        SubscriptionMatchedStatus
      >
    SubscriptionMatchedStatus_var;

  typedef
    SubscriptionMatchedStatus &
    SubscriptionMatchedStatus_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SubscriptionMatchedStatus
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SubscriptionMatchedStatus_var _var_type;
    typedef SubscriptionMatchedStatus_out _out_type;
    
    ::CORBA::Long total_count;
    ::CORBA::Long total_count_change;
    ::CORBA::Long current_count;
    ::CORBA::Long current_count_change;
    DDS::InstanceHandle_t last_publication_handle;
  };

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_LISTENER__VAR_OUT_CH_)
#define _DDS_LISTENER__VAR_OUT_CH_

  class Listener;
  typedef Listener *Listener_ptr;

  typedef
    TAO_Objref_Var_T<
        Listener
      >
    Listener_var;
  
  typedef
    TAO_Objref_Out_T<
        Listener
      >
    Listener_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_ENTITY__VAR_OUT_CH_)
#define _DDS_ENTITY__VAR_OUT_CH_

  class Entity;
  typedef Entity *Entity_ptr;

  typedef
    TAO_Objref_Var_T<
        Entity
      >
    Entity_var;
  
  typedef
    TAO_Objref_Out_T<
        Entity
      >
    Entity_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export Listener
    : public virtual ::CORBA::Object
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef Listener_ptr _ptr_type;
    typedef Listener_var _var_type;
    typedef Listener_out _out_type;

    // The static operations.
    static Listener_ptr _duplicate (Listener_ptr obj);

    static void _tao_release (Listener_ptr obj);

    static Listener_ptr _narrow (::CORBA::Object_ptr obj);
    static Listener_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static Listener_ptr _nil (void);

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    Listener (void);

    

    virtual ~Listener (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    Listener (const Listener &);

    void operator= (const Listener &);
  };

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_CONDITION__VAR_OUT_CH_)
#define _DDS_CONDITION__VAR_OUT_CH_

  class Condition;
  typedef Condition *Condition_ptr;

  typedef
    TAO_Objref_Var_T<
        Condition
      >
    Condition_var;
  
  typedef
    TAO_Objref_Out_T<
        Condition
      >
    Condition_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export Condition
    : public virtual ::CORBA::Object
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef Condition_ptr _ptr_type;
    typedef Condition_var _var_type;
    typedef Condition_out _out_type;

    // The static operations.
    static Condition_ptr _duplicate (Condition_ptr obj);

    static void _tao_release (Condition_ptr obj);

    static Condition_ptr _narrow (::CORBA::Object_ptr obj);
    static Condition_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static Condition_ptr _nil (void);

    virtual ::CORBA::Boolean get_trigger_value (
      void) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    Condition (void);

    

    virtual ~Condition (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    Condition (const Condition &);

    void operator= (const Condition &);
  };

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_WAITSETINTERF__VAR_OUT_CH_)
#define _DDS_WAITSETINTERF__VAR_OUT_CH_

  class WaitSetInterf;
  typedef WaitSetInterf *WaitSetInterf_ptr;

  typedef
    TAO_Objref_Var_T<
        WaitSetInterf
      >
    WaitSetInterf_var;
  
  typedef
    TAO_Objref_Out_T<
        WaitSetInterf
      >
    WaitSetInterf_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export WaitSetInterf
    : public virtual ::CORBA::Object
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef WaitSetInterf_ptr _ptr_type;
    typedef WaitSetInterf_var _var_type;
    typedef WaitSetInterf_out _out_type;

    // The static operations.
    static WaitSetInterf_ptr _duplicate (WaitSetInterf_ptr obj);

    static void _tao_release (WaitSetInterf_ptr obj);

    static WaitSetInterf_ptr _narrow (::CORBA::Object_ptr obj);
    static WaitSetInterf_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static WaitSetInterf_ptr _nil (void);

    virtual ::DDS::ReturnCode_t wait (
      ::DDS::ConditionSeq & active_conditions,
      const ::DDS::Duration_t & timeout) = 0;

    virtual ::DDS::ReturnCode_t attach_condition (
      ::DDS::Condition_ptr cond) = 0;

    virtual ::DDS::ReturnCode_t detach_condition (
      ::DDS::Condition_ptr cond) = 0;

    virtual ::DDS::ReturnCode_t get_conditions (
      ::DDS::ConditionSeq & attached_conditions) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    WaitSetInterf (void);

    

    virtual ~WaitSetInterf (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    WaitSetInterf (const WaitSetInterf &);

    void operator= (const WaitSetInterf &);
  };

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_GUARDCONDITIONINTERF__VAR_OUT_CH_)
#define _DDS_GUARDCONDITIONINTERF__VAR_OUT_CH_

  class GuardConditionInterf;
  typedef GuardConditionInterf *GuardConditionInterf_ptr;

  typedef
    TAO_Objref_Var_T<
        GuardConditionInterf
      >
    GuardConditionInterf_var;
  
  typedef
    TAO_Objref_Out_T<
        GuardConditionInterf
      >
    GuardConditionInterf_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export GuardConditionInterf
    : public virtual ::DDS::Condition
  
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef GuardConditionInterf_ptr _ptr_type;
    typedef GuardConditionInterf_var _var_type;
    typedef GuardConditionInterf_out _out_type;

    // The static operations.
    static GuardConditionInterf_ptr _duplicate (GuardConditionInterf_ptr obj);

    static void _tao_release (GuardConditionInterf_ptr obj);

    static GuardConditionInterf_ptr _narrow (::CORBA::Object_ptr obj);
    static GuardConditionInterf_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static GuardConditionInterf_ptr _nil (void);

    virtual ::DDS::ReturnCode_t set_trigger_value (
      ::CORBA::Boolean value) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    GuardConditionInterf (void);

    

    virtual ~GuardConditionInterf (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    GuardConditionInterf (const GuardConditionInterf &);

    void operator= (const GuardConditionInterf &);
  };

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_DDS_STATUSCONDITION__VAR_OUT_CH_)
#define _DDS_STATUSCONDITION__VAR_OUT_CH_

  class StatusCondition;
  typedef StatusCondition *StatusCondition_ptr;

  typedef
    TAO_Objref_Var_T<
        StatusCondition
      >
    StatusCondition_var;
  
  typedef
    TAO_Objref_Out_T<
        StatusCondition
      >
    StatusCondition_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export StatusCondition
    : public virtual ::DDS::Condition
  
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef StatusCondition_ptr _ptr_type;
    typedef StatusCondition_var _var_type;
    typedef StatusCondition_out _out_type;

    // The static operations.
    static StatusCondition_ptr _duplicate (StatusCondition_ptr obj);

    static void _tao_release (StatusCondition_ptr obj);

    static StatusCondition_ptr _narrow (::CORBA::Object_ptr obj);
    static StatusCondition_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static StatusCondition_ptr _nil (void);

    virtual ::DDS::StatusMask get_enabled_statuses (
      void) = 0;

    virtual ::DDS::ReturnCode_t set_enabled_statuses (
      ::DDS::StatusMask mask) = 0;

    virtual ::DDS::Entity_ptr get_entity (
      void) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    StatusCondition (void);

    

    virtual ~StatusCondition (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    StatusCondition (const StatusCondition &);

    void operator= (const StatusCondition &);
  };

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const USERDATA_QOS_POLICY_NAME = "UserData";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const DURABILITY_QOS_POLICY_NAME = "Durability";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const PRESENTATION_QOS_POLICY_NAME = "Presentation";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const DEADLINE_QOS_POLICY_NAME = "Deadline";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const LATENCYBUDGET_QOS_POLICY_NAME = "LatencyBudget";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const OWNERSHIP_QOS_POLICY_NAME = "Ownership";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const OWNERSHIPSTRENGTH_QOS_POLICY_NAME = "OwnershipStrength";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const LIVELINESS_QOS_POLICY_NAME = "Liveliness";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const TIMEBASEDFILTER_QOS_POLICY_NAME = "TimeBasedFilter";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const PARTITION_QOS_POLICY_NAME = "Partition";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const RELIABILITY_QOS_POLICY_NAME = "Reliability";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const DESTINATIONORDER_QOS_POLICY_NAME = "DestinationOrder";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const HISTORY_QOS_POLICY_NAME = "History";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const RESOURCELIMITS_QOS_POLICY_NAME = "ResourceLimits";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const ENTITYFACTORY_QOS_POLICY_NAME = "EntityFactory";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const WRITERDATALIFECYCLE_QOS_POLICY_NAME = "WriterDataLifecycle";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const READERDATALIFECYCLE_QOS_POLICY_NAME = "ReaderDataLifecycle";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const TOPICDATA_QOS_POLICY_NAME = "TopicData";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const GROUPDATA_QOS_POLICY_NAME = "GroupData";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const TRANSPORTPRIORITY_QOS_POLICY_NAME = "TransportPriority";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const LIFESPAN_QOS_POLICY_NAME = "Lifespan";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const DURABILITYSERVICE_POLICY_NAME = "DurabilityService";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long INVALID_QOS_POLICY_ID = 0;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long USERDATA_QOS_POLICY_ID = 1;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DURABILITY_QOS_POLICY_ID = 2;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long PRESENTATION_QOS_POLICY_ID = 3;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DEADLINE_QOS_POLICY_ID = 4;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long LATENCYBUDGET_QOS_POLICY_ID = 5;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long OWNERSHIP_QOS_POLICY_ID = 6;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long OWNERSHIPSTRENGTH_QOS_POLICY_ID = 7;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long LIVELINESS_QOS_POLICY_ID = 8;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long TIMEBASEDFILTER_QOS_POLICY_ID = 9;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long PARTITION_QOS_POLICY_ID = 10;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RELIABILITY_QOS_POLICY_ID = 11;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DESTINATIONORDER_QOS_POLICY_ID = 12;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long HISTORY_QOS_POLICY_ID = 13;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long RESOURCELIMITS_QOS_POLICY_ID = 14;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long ENTITYFACTORY_QOS_POLICY_ID = 15;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long WRITERDATALIFECYCLE_QOS_POLICY_ID = 16;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long READERDATALIFECYCLE_QOS_POLICY_ID = 17;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long TOPICDATA_QOS_POLICY_ID = 18;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long GROUPDATA_QOS_POLICY_ID = 19;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long TRANSPORTPRIORITY_QOS_POLICY_ID = 20;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long LIFESPAN_QOS_POLICY_ID = 21;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DURABILITYSERVICE_QOS_POLICY_ID = 22;

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class OpenDDS_Dcps_Export Entity
    : public virtual ::CORBA::Object
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef Entity_ptr _ptr_type;
    typedef Entity_var _var_type;
    typedef Entity_out _out_type;

    // The static operations.
    static Entity_ptr _duplicate (Entity_ptr obj);

    static void _tao_release (Entity_ptr obj);

    static Entity_ptr _narrow (::CORBA::Object_ptr obj);
    static Entity_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static Entity_ptr _nil (void);

    virtual ::DDS::ReturnCode_t enable (
      void) = 0;

    virtual ::DDS::StatusCondition_ptr get_statuscondition (
      void) = 0;

    virtual ::DDS::StatusMask get_status_changes (
      void) = 0;

    virtual ::DDS::InstanceHandle_t get_instance_handle (
      void) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    Entity (void);

    

    virtual ~Entity (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    Entity (const Entity &);

    void operator= (const Entity &);
  };

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module DDS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const char *const TRANSPORTTYPE_QOS_POLICY_NAME = "TransportType";

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long TRANSPORTTYPE_QOS_POLICY_ID = 2147483647;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long MAX_USER_DOMAINID = 2147483647;

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace DCPS
  {

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::ULong ALL_STATUS_MASK = 4294967295U;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::ULong NO_STATUS_MASK = 0U;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::ULong DEFAULT_STATUS_MASK = 4294967295U;
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::DCPS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::InconsistentTopicStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::InconsistentTopicStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SampleLostStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::SampleLostStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::SampleRejectedStatusKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::SampleRejectedStatusKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SampleRejectedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::SampleRejectedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::LivelinessLostStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::LivelinessLostStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::LivelinessChangedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::LivelinessChangedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::OfferedDeadlineMissedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::OfferedDeadlineMissedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::RequestedDeadlineMissedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::RequestedDeadlineMissedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::OfferedIncompatibleQosStatus>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::OfferedIncompatibleQosStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::RequestedIncompatibleQosStatus>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::RequestedIncompatibleQosStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PublicationMatchedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::PublicationMatchedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SubscriptionMatchedStatus>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::SubscriptionMatchedStatus,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{

#if !defined (_DDS_LISTENER__TRAITS_)
#define _DDS_LISTENER__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::Listener>
  {
    static ::DDS::Listener_ptr duplicate (
        ::DDS::Listener_ptr p);
    static void release (
        ::DDS::Listener_ptr p);
    static ::DDS::Listener_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::Listener_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_DDS_CONDITION__TRAITS_)
#define _DDS_CONDITION__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::Condition>
  {
    static ::DDS::Condition_ptr duplicate (
        ::DDS::Condition_ptr p);
    static void release (
        ::DDS::Condition_ptr p);
    static ::DDS::Condition_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::Condition_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_DDS_WAITSETINTERF__TRAITS_)
#define _DDS_WAITSETINTERF__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::WaitSetInterf>
  {
    static ::DDS::WaitSetInterf_ptr duplicate (
        ::DDS::WaitSetInterf_ptr p);
    static void release (
        ::DDS::WaitSetInterf_ptr p);
    static ::DDS::WaitSetInterf_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::WaitSetInterf_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_DDS_GUARDCONDITIONINTERF__TRAITS_)
#define _DDS_GUARDCONDITIONINTERF__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::GuardConditionInterf>
  {
    static ::DDS::GuardConditionInterf_ptr duplicate (
        ::DDS::GuardConditionInterf_ptr p);
    static void release (
        ::DDS::GuardConditionInterf_ptr p);
    static ::DDS::GuardConditionInterf_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::GuardConditionInterf_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_DDS_STATUSCONDITION__TRAITS_)
#define _DDS_STATUSCONDITION__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::StatusCondition>
  {
    static ::DDS::StatusCondition_ptr duplicate (
        ::DDS::StatusCondition_ptr p);
    static void release (
        ::DDS::StatusCondition_ptr p);
    static ::DDS::StatusCondition_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::StatusCondition_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_DDS_ENTITY__TRAITS_)
#define _DDS_ENTITY__TRAITS_

  template<>
  struct OpenDDS_Dcps_Export Objref_Traits< ::DDS::Entity>
  {
    static ::DDS::Entity_ptr duplicate (
        ::DDS::Entity_ptr p);
    static void release (
        ::DDS::Entity_ptr p);
    static ::DDS::Entity_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::DDS::Entity_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::InconsistentTopicStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::InconsistentTopicStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SampleLostStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SampleLostStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::SampleRejectedStatusKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::SampleRejectedStatusKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SampleRejectedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SampleRejectedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::LivelinessLostStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::LivelinessLostStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::LivelinessChangedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::LivelinessChangedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::OfferedDeadlineMissedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::OfferedDeadlineMissedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::RequestedDeadlineMissedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::RequestedDeadlineMissedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::OfferedIncompatibleQosStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::OfferedIncompatibleQosStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::RequestedIncompatibleQosStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::RequestedIncompatibleQosStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PublicationMatchedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PublicationMatchedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SubscriptionMatchedStatus &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SubscriptionMatchedStatus &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "DdsDcpsInfrastructureC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

